;===============================================================
;  MSX STAR SOLDIER
;
;	地上物爆発
;
;===============================================================
org		#5490

val_5490_in_rom_132e	equ	put_bg_explode_16x16
val_5490_in_rom_1361	equ	put_bg_explode_16x16
val_5490_in_rom_1421	equ	put_bg_explode_16x16
val_5490_in_rom_146d	equ	put_bg_explode_16x16


val_5507_in_rom_131e	equ	put_bg_explode_32x32
val_5507_in_rom_1373	equ	put_bg_explode_32x32


val_5650_in_rom_131b	equ	put_dust_map_parts_32x32
val_5650_in_rom_1370	equ	put_dust_map_parts_32x32


;========================================
;	爆発キャラ書き出し16x16
;========================================
put_bg_explode_16x16:
proc
		ld		bc,tbl_560b+20
		call	put_bg_explode_sprite		; 爆発spr追加

		call	get_bg_adr_from_ce74
		ld		a,#25
		jp		putchr16x16					; hlにキャラ0x21を書き出し
endp

;========================================
;	爆発キャラ書き出し32x32
;========================================
put_bg_explode_32x32:
proc
		ld		bc,tbl_560b
		call	put_bg_explode_sprite		; 爆発spr追加
		ld		bc,tbl_560b+5
		call	put_bg_explode_sprite_2		; 爆発spr追加

		call	get_bg_adr_from_ce74_to_ce7c
		ld		a,#21
		call	putchr16x16					; hlにキャラ0x21を書き出し


		; 右に
		ld		hl,(#ce7c)
		inc		hl
		ld		a,(#ce74)
		cp		19
		jr		c,_on_border0
		ld		bc,-20
		add		hl,bc
	_on_border0:
		ld		a,#22
		call	putchr16x16					; hlにキャラ0x22を書き出し

		ld		hl,#ce78
		ld		a,(hl)
		add		a,#10
		ld		(hl),a

		ld		bc,tbl_560b+10
		call	put_bg_explode_sprite_2		; 爆発spr追加
		ld		bc,tbl_560b+15
		call	put_bg_explode_sprite_2		; 爆発spr追加

		ld		hl,(#ce7c)					; 下に
		ld		bc,32*2
		add		hl,bc
		ld		a,#23
		call	putchr16x16					; hlにキャラ0x23を書き出し

		ld		hl,(#ce7c)					; 右下に
		ld		bc,32*2+1
		ld		a,(#ce74)
		cp		19
		jr		c,_on_border1
		ld		bc,32*2-19
	_on_border1:
		add		hl,bc
		ld		a,#24
		jp		putchr16x16					; hlにキャラ0x24を書き出し
endp


explode_sprite_xpos_tbl:
proc
ofs	equ	4
		db		  0+ofs,  12+ofs,  25+ofs,  38+ofs,  51+ofs,  64+ofs,  76+ofs,  89+ofs
		db		102+ofs, 115+ofs, 128+ofs, 140+ofs, 153+ofs, 166+ofs, 179+ofs, 192+ofs
		db		204+ofs, 217+ofs, 230+ofs, 243+ofs
endp


;========================================
;	地上物 爆発スプライト追加　共通
;		(i)bc:	tbl_560b+xのポインタ
;========================================
put_bg_explode_sprite:
proc
		; 自弾消す
		ld		hl,#cdf3	; 自弾バッファ
		ld		d,0
		add		hl,de
		ld		(hl),0		; 消す
		ld		a,4			; SE:4 爆発音
		ld		(#ce89),a		;

		; 爆風の座標 BGにスナップ
		; x
		ld		a,(#ce74)
		ld 		h,explode_sprite_xpos_tbl>>8
		add		a,explode_sprite_xpos_tbl
		ld		l,a
		if	0xec < explode_sprite_xpos_tbl & 0x0ff
			jr		nc,_nc
			inc		h
		endif
	_nc:
		ld		h,(hl)

		; y
		ld		a,(#ce75)
		rlca
		rlca
		rlca
		rlca
		and		#f0
		sub		8
		ld		l,a

		ld		a,(#cf19)
		sub		2
		and		#f
		add		a,l
		ld		l,a

		ld		(#ce78),hl	;(y,x)

endp
;========================================
;	地上物 爆発スプライト追加　共通2
;		(i)bc:	tbl_560b+xのポインタ
;========================================
put_bg_explode_sprite_2:
proc
		push	de
		ld		d,b
		ld		e,c

		; 爆風の空き検索 c=a=++[0xcf24] (範囲13-23)
		ld		hl,#cf24
		inc		(hl)
		ld		a,(hl)
		cp		13
		jr		c,_564b
		cp		#18
		jr		c,_564e
	_564b:
		ld		a,13
		ld		(hl),a
	_564e:
		ld		b,0
		ld		c,a

		; 爆風データセット
		ld		a,(de)			; 26/27
		inc		e			
		ld		hl,#c000
		add		hl,bc
		ld		(hl),a

		ld		a,(#ce78)
		ld		l,#30			; ey
		add		hl,bc
		ld		(hl),a

		ld		a,(#ce79)
		ex		de,hl
		add		a,(hl)			; x ofs
		ex		de,hl
		inc		e
		ld		l,#18			; ex
		add		hl,bc
		ld		(hl),a

		ld		l,#60
		add		hl,bc
		ld		(hl),0

		ld		a,(#ce74)
		ex		de,hl
		add		a,(hl)			; ce74+(0/1)
		ex		de,hl
		inc		e
		ld		l,#a8
		add		hl,bc
		ld		(hl),a

		ld		a,(de)			; 10/11/12/13/c
		inc		e
		ld		l,#48
		add		hl,bc
		ld		(hl),a

		ld		a,(de)			; 80/90/a0/b0/c0
		ld		hl,0xc198
		add		hl,bc
		ld		(hl),a
		ld		l,#b0
		add		hl,bc
		ld		(hl),a
		ld		l,#c8
		add		hl,bc
		ld		(hl),#fa

		pop		de
		ret
endp

tbl_560b:
		db		#26,#00,0,#10,#80
		db		#26,#0c,1,#11,#90
		db		#26,#00,0,#12,#a0
		db		#26,#0c,1,#13,#b0
		db		#27,#00,0,#0c,#c0




;=======================================
;
;	hlにキャラaを書き出し
;
; (i)hl				bgのオフセットアドレスと、map x
;
;=======================================
putchr16x16_plusHalf:
		ld		b,1
		jp		putchr16x16_plusHalf_
putchr16x16:
		ld		b,0
putchr16x16_plusHalf_:
		push	de
		call	proc_5c47		; mapピース→mapBG番号格納アドレス変換 de=0x7c96+a*4
		ex		de,hl
;=======================================
;
;	hlにキャラaを書き出し
;
; (i)hl				chr src
; (i)de				bgのオフセットアドレスと、map x
; (i)b				bgの追加xオフセット
;=======================================
putchr16x16_:
proc
		; オフセット→vram adrに
		ld		a,d
		and		#03
		or		#40
		ld		d,a

		; ポート取得
		ld		a,(#0007)
		ld		c,a

		; vram上位アドレスセット
		ld		a,d
		rlca
		rlca
		and		3

		inc		c
		di
		out		(c),a
		ld		a,#8e
		out		(c),a
		ei
		dec		c

		; vram下位アドレスとxのオフセットを別管理
		ld		a,e
		and		#e0
		ld		ixl,a	; vram low adr
		ld		a,e
		and		#1f
		add		a,a		; map x→bg x
		add		a,b		; 追加のx ofs
		ld		e,a		; vram x ofs(ただし、31オーバーな場合がある)

		; 二行分行う
		ld		ixh,2

	_lpY:
		push	de
		ld		b,8

		ld		a,e
		cp		7
		jr		c,_cutL
		cp		31
		jr		c,_putLR
	;_cutR:					; 1f<=x
		; 描画範囲になるプレーンまで移動
		sub		31
		ld		b,a
		add		a,a
		add		a,a
		add		a,d
		ld		d,a	
		; クリップなし描画回数=x-31
		ld		a,7
		sub		b
		ld		b,a
		add		a,a
		add		a,b
		inc		a
		ld		b,a
		; 画面右端に左側描画
		ld		e,31
		ld		a,e
		add		a,ixl
		inc		c
		di
		out		(c),a
		out		(c),d
		ei
		dec		c
		ld		a,(hl)
		out		(c),a
		inc		b
		dec		b
		jp		p,_putLR2
		jp		_next_line
	_cutL:					; x<7
		; クリップなし描画回数=x+1
		inc		a
		ld		b,a
	_putLR:
		; 繰り返し回数修正(djnz+outi+outd)
		ld		a,b
		add		a,a
		add		a,b
		ld		b,a
	_lp_putLR:
		; 各プレーンにクリップなしの描画
		ld		a,ixl		; yオフセットアドレス
		add		a,e			; xオフセットアドレス
		inc		c
		di
		out		(c),a
		out		(c),d
		dec		c
		outi
		ei
		outd
	_putLR2:
		; 次のプレーンに
		ld		a,d
		add		a,4
		ld		d,a
		; プレーン内x座標修正
		dec		e
		djnz	_lp_putLR

		jp		p,_next_line
	;_putR:
		; 画面左端に右側描画
		ld		a,ixl
		inc		c
		di
		out		(c),a
		out		(c),d
		ei
		dec		c
		inc		hl
		ld		a,(hl)
		out		(c),a
		dec		hl

	_next_line:
		pop		de
		dec		ixh
		jr		z,put16x16_ret

		; 下段側のソースへ
		inc		hl
		inc		hl

		; y座標を下段へ
		ld		a,ixl
		add		a,32
		ld		ixl,a
		jp		nc,_lpY
		inc		d
		ld		a,d
		and		#03
		or		#40
		ld		d,a
		jp		_lpY
endp
put16x16_ret:
		pop		de
		ret
