;===============================================================
;  MSX STAR SOLDIER
;
;	メッセージ表示処理
;
;===============================================================
org	#580e

; ゲームオーバー時、メッセージの再設定はしない(重いので)
val_db_in_rom_034e		equ	#e0				; JR nz,0x432a　→　0x432f
val_d5_in_rom_0354		equ	#da				; JR nz,0x432a　→　0x432f

; デモのときの表示
val_cd_in_rom_0a28		equ	#21				; CALL 0x580e	→　意味のないhl代入に


;===============================================================
; メッセージ表示要求
;===============================================================
proc_580e:
		ld		(#ce68),a
		ld		a,#ff			; #ff:セットアップ
		ld		(#ce69),a
		ret

;===============================================================
; メッセージ表示周期処理
;===============================================================
;_5817:
proc
		ld		a,(0xce5a)
		or		a
		ld		hl,#ce69
		ld		a,(hl)
		jr		nz,_demo
		or		a
		ret		z

		inc		a
		jp		z,setup_message
		inc		a				; #fe:永久表示(GAME OVER用)
		ret		z

		dec		(hl)
		ret		nz

		xor		a
		ld		(hscan_adr+1),a
		jp		clear_msg_area
_demo:
		dec		l
		ld		(hl),3
		cp		#fe
		call	nz,setup_message
		ret
endp

;===============================================================
; メッセージ定義	※8bit範囲に収まるように
;===============================================================
bonus_dat:
		db	2<<6|#38,4		;  80000
		db	1<<6|#32,6		; 2000000
		db	2<<6|#34,4		;  40000
		db	2<<6|#31,4		;  10000
		db	3<<6|#34,3		;   4000
		db	3<<6|#31,3		;   3000
		db	3<<6|#35,2		;   500
		db	2<<6|#38,4		;  80000

msg_ptr_lst:
		db	msg_1,msg_2,msg_3,msg_4,msg_5,msg_6,msg_7,msg_8,msg_9
			; ypos256/term, vramL, len, str/special, …
msg_1:	db	#07*8+8-3,#ed,5,"STAGE",		#09*8+8-3,#2f,#fe,				#0b*8+8-3,#6d,5,"START",#00		; STAGE	START
msg_2:	db	#0c*8+8-3,#8d,5,"PAUSE",		#00																; PAUSE
msg_3:	db	#07*8+8-3,#ee,4,"GAME",			#09*8+8-3,#2e,4,"OVER",			#00								; GAME OVER
msg_4:	db	#06*8+8-3,#cd,6,"ATTACK",		#08*8+8-3,#0c,8,"BIG",0,"STAR",	#0a*8+8-3,#4d,6,"!\"#$%&",#00	; ATTACK BIG STAR BRAIN
msg_5:	db	#06*8+8-3,#cd,6,"ATTACK",		#08*8+8-3,#0e,4,"STAR",			#0a*8+8-3,#4d,6,"!\"#$%&",#00	; ATTACK STAR BRAIN
msg_6:	db	#06*8+8-3,#cd,5,"BONUS",		#08*8+8-3,#0b,#ff,				#00 							; BONUS
msg_7:	db	#06*8+8-3,#cd,5,"BRAIN",		#08*8+8-3,#0c,7,"ESCAPED",		#00								; BRAIN ESCAPED 
msg_8:	db	#06*8+8-3,#ce,4,"WARP",			#08*8+8-3,#0e,4,"NEXT",			#0a*8+8-3,#4d,6,"()*+,-",#00	; WARP NEXT STAGE
msg_9:	db	#08*8+8-3,#0c,8,"COMPLETE",		#0a*8+8-3,#4e,4,"WARP",			#00								; COMPLETE WARP



;===============================================================
; メッセージ表示エリアクリア
;===============================================================
clear_msg_area:
proc
		ld		de,#3800+6*32+12
        ld		hl,#20
	_cls_lp:
		call	set_vram_adr_de
		ld		b,8
	_cls_lp_line:
		out		(c),h
		djnz	_cls_lp_line
        ex		de,hl
        add		hl,de
        ex		de,hl
		ld		a,e
		cp		#3800+6*32+12+6*32
		jr		nz,_cls_lp
		ret
endp
;===============================================================
; メッセージ表示
;===============================================================
setup_message:
proc
		call	clear_msg_area

		ld		hl,#ce68
		ld		a,(hl)		; メッセージ番号取得

		; メッセージ表示時間セット
		ld		c,10*8
		cp		#3
		jr		nz,_finite
		ld		c,#fe		; ずっと表示
	_finite:
		inc		l
		ld		(hl),c

		; メッセージ定義アドレス取得
		and		15
		add		a,msg_ptr_lst-1			; 8bit範囲内
		ld		l,a
		ld		h,(msg_ptr_lst-1)>>8
		ld		l,(hl)

		ld		ix,hscan_adr+1
	_lp:
		ld		a,(hl)
		or		a
		ret		z
		inc		hl

		; メッセージhscan追加
		ld		(ix+2),0
		ld		(ix+1),a
		sub		8+2
		ld		(ix+0),a
		inc		ix
		inc		ix

		; set vram adr
		ld		d,#38
		cp		64			-8; スキャンライン遅延分甘めに
		jr		c,_vram38
		inc		d
	_vram38:
		ld		e,(hl)
		inc		hl
		call	set_vram_adr_de

		; check type
		ld		a,(hl)
		inc		hl
		cp		#fe
		jr		z,_put_stage_no
		cp		#ff
		jr		z,_put_bonus

		; put str
		ld		b,a
		otir
		jr		_lp

	_put_stage_no:
		ld		a,(#cde4)	; ステージ数
		cp		10
		jr		c,_end_ten
		ld		b,#31
		out		(c),b
		sub		10
	_end_ten:
		add		a,#30
		out		(c),a
		jr		_lp
		
	_put_bonus:
		ld		a,(#ce68)
		rrca
		rrca
		rrca
		and		#0e
		add		a,bonus_dat			; 8bit範囲内
		ld		e,a
		ld		d,bonus_dat>>8

		ld		a,(de)
		rlca
		rlca
		and		3
		ld		b,a
		xor		a
	_lp_space:
		out		(c),a
		djnz	_lp_space
	_end_space:
		ld		a,(de)
		and		#3f
		out		(c),a
		inc		e					; 8bit範囲内
		ld		a,(de)
		ld		b,a
		ld		a,#30
	_lp_zero:
		out		(c),a
		djnz	_lp_zero

		jr		_lp
endp
