;===============================================================
;  MSX STAR SOLDIER
;
;	map周期処理
;	map展開エリアスクロール
;	map展開エリアからmapBGエリアへ一行展開	軽量化3600→2400
;	mapピース→mapBG番号格納アドレス変換 de=0x7c96+a*4
;
;===============================================================
;
;	map			bg			bg:boss			pnt
;	+0:0xcc89	+0:0xc288
;							L:0xc2b0+10
;	+1						
;
;	+2:0xcc9d	+4:0xc328					-1:0x43e0
;							S:0xc350+13		+0:0x4000	(#3800)
;				+6:0xc378	+6:0xc378		+1:0x4020
;
;===============================================
;
;	map周期処理
;		proc_5bf8			; map展開エリアスクロール +BG基準y座標修正
;		proc_5cca			; map一行展開 + map展開エリアからmapBGへ一行展開（下段）
;							; 何もしない
;							; 何もしない
;		update_cur_bg_y		; BG基準y座標修正
;		proc_5c2e			; map展開エリアからmapBGへ一行展開（上段）
;							; 何もしない
;		proc_5ddd			; 0xcdde:シーン進行カウンタ更新、0xcf21:map進行カウンタ更新
;
;===============================================
proc_5b8c_gameover:
		ld		a,(#ce7e)	; ボス登場待ちチェック
		or		a
		jp		nz,on_pre_boss_scroll
val_5b8c_in_rom_033f	equ	proc_5b8c_gameover

proc_5b8c:
proc
		call	put_bg_1line_1plane	; BG書く

		xor		a
		ld		(#cde1),a

		ld		hl,#cf19
		bit		0,(hl)
		ret		nz

		dec		l
		dec		(hl)

		ld		a,(hl)
		and		7
		cp		7
		jp		z,proc_5bf8			; map展開エリアスクロール + BG基準y座標修正
		cp		6
		jp		z,proc_5cca			; map一行展開 + map展開エリアからmapBGへ一行展開（下段）
		cp		2
		jp		z,proc_5c2e			; map展開エリアからmapBGへ一行展開（上段）
		or		a
		jp		z,proc_5ddd			; 0xcdde:シーン進行カウンタ更新、0xcf21:map進行カウンタ更新
		cp		3
		jp		z,update_cur_bg_y	; BG基準y座標修正

		ret
endp
val_5b8c_in_rom_011d	equ	proc_5b8c



;===============================================
;	map 1サイクル目処理
;===============================================
proc_5bf8:
		; map展開エリアスクロール
		ld		hl,#cda0
		ld		de,#cdb4	; +20
		ld		bc,#118		; 20x14
		lddr
;===============================================
;
;	BG基準y座標修正
;
;===============================================
update_cur_bg_y:
		ld		hl,#cde1
		inc		(hl)
		ld		hl,cur_bg_y
		dec		(hl)
		ret


;===============================================
;	map 5サイクル目処理
;===============================================
proc_5c2e:
		;	map展開エリアからmapBGへ一行展開（上段）
		ld		ixl,0
		ld		a,(cfg_trapzone_mode)
		cp		2
		jp		nz,decode_map_bg_1line
		jp		decode_map_bg_1line_trapopen


;===============================================
;	map 2サイクル目処理
;===============================================
proc_5cca:
		call	put_map_1line

		;	map展開エリアからmapBGへ一行展開（下段）
		ld		ixl,1
		ld		a,(cfg_trapzone_mode)
		cp		2
		jr		z,decode_map_bg_1line_trapopen
;===============================================
;
;	map展開エリアからmapBGへ一行展開
;
;===============================================
decode_map_bg_1line:
proc
		ld		bc,#cc89	; map展開エリア
		ld		de,#c288	; mapBG展開エリア
	_lp:
		ld		a,(bc)
		; mapピース→mapBG番号格納アドレス変換 de=0x7c96+a*4
		ld		hl,#1f96	; hl: 0x7c00>>2 + 0x0096
		or		a
		rla
		rl		h
		add		a,ixl		; 上段/下段
		rla
		rl		h
		add		a,l
		ld		l,a
		jr		nc,_ldi
		inc		h
	_ldi:
		; mapBG展開エリアにコピー
		ldi
		ldi
		ld		a,c
		add		a,3
		ld		c,a
		cp		#89+20
		jr		nz,_lp

		jp		put_bg_1line_cyclestart	; bg書き込みサイクル開始
endp
decode_map_bg_1line_trapopen:
proc
		ld		bc,#cc89	; map展開エリア
		ld		de,#c288	; mapBG展開エリア
	_lp:
		ld		a,(bc)
		cp		#96
		jr		z,_trap_open
		; mapピース→mapBG番号格納アドレス変換 de=0x7c96+a*4
		ld		hl,#1f96	; hl: 0x7c00>>2 + 0x0096
		or		a
		rla
		rl		h
		add		a,ixl		; 上段/下段
		rla
		rl		h
		add		a,l
		ld		l,a
		jr		nc,_ldi
		inc		h
	_ldi:
		; mapBG展開エリアにコピー
		ldi
		ldi
		ld		a,c
		add		a,3
		ld		c,a
		cp		#89+20
		jr		nz,_lp

		jp		put_bg_1line_cyclestart	; bg書き込みサイクル開始
	_trap_open:
		ld		hl,_trap_pcg
		jp		_ldi
	_trap_pcg:
		db		#b6,#b6
endp


;===============================================================
;
;	mapピース→mapBG番号格納アドレス変換 de=0x7c96+a*4
;
;===============================================================
proc_5c47:
proc
		ld		de,#1f96	; 0x7c00>>2 + 0x0096
		or		a
		rla
		rl		d
		rla
		rl		d
		add		a,e
		ld		e,a
		jr		nc,_ret		; 9割がinc dする
		inc		d
	_ret:
		ret
endp


;===============================================================
;
;	map一行展開
;
;===============================================================
put_map_1line:
proc
		ld		a,(#cdde)
		or		a
		jr		nz, proc_5d1c
	_put:
		ld		hl,(0xcddf)
		ld		de,0xcc89
		ld		bc,20

		; 左右反転チェック
		ld		a,(#cde3)
		or		a
		jr		z,_normal
		ld		a,(#cf21)
		cp		#f0
		jr		nc,_normal

		; 左右反転
		ld		e,#cc89 + 10
		ld		c,10
		ldir
		ld		e,#cc89
		ld		c,10
	_normal:
		ldir
		ld		(0xcddf),hl

		ret
endp
;===============================
; map展開エリア、一行クリア
;===============================
proc_5d1c:
		ld		hl,#cc89
		ld		(hl),#26
		ld		de,#cc8a
		ld		bc,19
		ldir
		ret
