;===============================================================
;  MSX STAR SOLDIER
;
;	マップ処理 続き
;
;===============================================================
;===============================
; bg一行書き込み
;===============================
put_bg_1line:
proc
		ld		b,8
	_lp:
		push	bc
		call	put_bg_1line_1plane
		pop		bc
		djnz	_lp
endp
;===============================
; bg一行書き込みサイクル開始
;===============================
put_bg_1line_cyclestart:
		call	update_cur_bg_adr
		ld		l,h
		ld		h,#88
		ld		(cur_putbg_state),hl
		ret

;===============================
; bg一行1プレーン書き込み
;===============================
put_bg_1line_1plane:
proc
		ld		hl,cur_bg_adr
		ld		e,(hl)
		inc		l
		inc		l
		ld		d,(hl)
		call	set_vram_adr_de
		add		a,4
		ld		(hl),a
		inc		l
		ld		a,(hl)
		inc		(hl)
		ld		l,a
		ld		h,#c2

		; 星のアドレス取得
		ld		de,(cur_bg_adr)
		ld		a,d
		add		a,#c3-#40
		ld		d,a

		ld		b,32
	_lpL:
		ld		a,(hl)
		or		a
		jr		nz,_put
		ld		a,(de)
	_put:
		out		(c),a
		inc		l
		inc		e
		djnz	_lpL

		ret
endp

;===============================
; 次回bg書き込み行更新
;===============================
update_cur_bg_adr:
proc
		ld		hl,(cur_bg_adr)
		ld		de,-#20
		add		hl,de
		bit		6,h
		jr		nz,_set
		ld		h,#43
	_set:
		ld		(cur_bg_adr),hl
		ret
endp




;===============================
; シーン,map進行
; mapデータ展開
;===============================
proc_5ddd:
proc
		ld		hl,#cdde		; if [cdde] != 0:
		ld		a,(hl)				;
		or		a					;
		jr		nz,_5e06			; マップ外の処理へ

		; [cdde]が0の間、マップ処理
		ex		de,hl			; [cf21]++
		ld		hl,#cf21			;
		inc		(hl)				;
		ld		a,(hl)			; if [cf21] == 0:
		or		a					;
		jr		z,_5e00				; マップ終了、ボス戦へ

		; 後半マップの場合、ここで処理終了
		cp		#81
		ret		nc

		; 前半マップ終了判定
		ld		c,a
		ld		a,(cfg_map_type)
		or		a
		ld		a,#6f-1
		jr		z,_check_end
		ld		a,#80-1			; NESは長さが違う
	_check_end:
		cp		c
		ret		nc
		ld		(hl),#80		; [cf21] 後半マップへ
		ld		a,#ef			; [cdde] マップ外処理へ
		ld		(de),a				;
		ret

		; ボス戦へ
	_5e00:							;
		ld		a,1					; [cdde] = 1
		ld		(de),a					;
		ret							; ret

		; マップ外処理
	_5e06:						;
		inc		(hl)			; [cdde] ++
		ret		nz				; if [cdde]:
load_map:
		ld		a,(#cf21)		; if [cf21]:
		rlca
		jr		nc,_1st

		ld		hl,(#cde7)
		ld		a,(#ce6b+4)
		jr		_set
	_1st:
		ld		hl,(#cde5)
		ld		a,(#ce6b)
	_set:
		ld		(#cde3),a
		ld		de,map_data
		ld		(#cddf),de

		ld		a,(current_bank_A000)
		push	af
		ld		a,bank_mapfc
		call	set_bank_A000
		call	DecompressLZSA
		pop		af
		jp		set_bank_A000
endp


;===============================
; mapアドレス[0xcde5:4]セット [0xce6b:8]セット
;===============================
proc_48a0:
		ld		a,(#cde4)
		dec		a
		ld		b,a
		add		a,a
		add		a,a
		ld		hl,(cfg_map_list_adr)
		ld		d,0
		ld		e,a
		add		hl,de
		ld		de,#cde5
		ld		a,b
		ld		bc,4
		ldir

		ld		hl,(cfg_map_list_adr)
		add		a,64
		ld		e,a
		ld		d,0
		add		hl,de
		ld		b,8
		ld		de,#ce6b
		ld		c,(hl)
	_lp:
		xor		a
		rl		c
		rla
		ld		(de),a
		inc		de
		djnz	_lp
		ret
val_48a0_in_rom_00f0	equ	proc_48a0




;===============================
; 面-mapデータ 対応
;===============================
map_list_msx:
		dw	map2_lzsa, map2_lzsa
		dw	map2_lzsa, map1_lzsa
		dw	map1_lzsa, map2_lzsa
		dw	map1_lzsa, map1_lzsa
		dw	map0_lzsa, map1_lzsa
		dw	map2_lzsa, map0_lzsa
		dw	map0_lzsa, map2_lzsa
		dw	map1_lzsa, map1_lzsa
		dw	map2_lzsa, map0_lzsa
		dw	map0_lzsa, map2_lzsa
		dw	map1_lzsa, map1_lzsa
		dw	map2_lzsa, map0_lzsa
		dw	map0_lzsa, map2_lzsa
		dw	map1_lzsa, map1_lzsa
		dw	map2_lzsa, map0_lzsa
		dw	map0_lzsa, map0_lzsa
map_fx_msx:;	equ	#48da
		db	#91, #99, #11, #99, #11, #99, #00, #80	; 面処理フラグ[3bit:反転 2bit:? 1bit:? 0bit:?]x2
		db	#11, #99, #11, #99, #00, #88, #11, #90
map_list_fc:
		dw	mapfc2_lzsa, mapfc6_lzsa
		dw	mapfc2_lzsa, mapfc6_lzsa
		dw	mapfc0_lzsa, mapfc4_lzsa
		dw	mapfc0_lzsa, mapfc4_lzsa
		dw	mapfc2_lzsa, mapfc6_lzsa
		dw	mapfc2_lzsa, mapfc6_lzsa
		dw	mapfc1_lzsa, mapfc5_lzsa
		dw	mapfc1_lzsa, mapfc8_lzsa
		dw	mapfc0_lzsa, mapfc4_lzsa
		dw	mapfc0_lzsa, mapfc4_lzsa
		dw	mapfc3_lzsa, mapfc7_lzsa
		dw	mapfc3_lzsa, mapfc7_lzsa
		dw	mapfc1_lzsa, mapfc5_lzsa
		dw	mapfc1_lzsa, mapfc5_lzsa
		dw	mapfc3_lzsa, mapfc7_lzsa
		dw	mapfc2_lzsa, mapfc8_lzsa
map_fx_fc:
		db	#11, #99, #11, #99, #11, #99, #00, #80	; 面処理フラグ[3bit:反転 2bit:? 1bit:? 0bit:?]x2
		db	#11, #99, #11, #99, #00, #88, #11, #90
