;===============================================================
;  MSX STAR SOLDIER
;
;	割り込み
;
;===============================================================
my_hkey_src:
org		my_hkey_org



;===============================================================
;	割り込み
;===============================================================
my_hkeyi:
		;VDP入出力ポート取得
		ld		bc,#9999
proc
		;vblankかチェック
		ld		hl,#8f01
		out		(c),l
		out		(c),h
		ld		a,c
		ld		c,b
		in		d,(c)
		ld		c,a

		;ステータスレジスタ0セレクト
		xor		a
		out		(c),a
		out		(c),h

		rrc		d
		jr		c,on_hscan
	;垂直帰線割り込み
	;_vblank:
		; スプライト表示停止
		ld		hl,#880a
		out		(c),l
		out		(c),h

		call	hscan_proc_textscreen

		; 表示ページ切り替え
		ld		hl,back_page
		ld		a,(hl)
		sub		4
		and		#0f
		dec		l		; fore_page
		ld		(hl),a

		; 表PGTセット
		ld		hl,star_back_page
		ld		a,(hl)
		sub		star_page_size
		cp		star_page_tbl
		jr		nc,_sw_star_page
		ld		a,star_page_tbl+star_page_size*(star_page_cnt-1)
	_sw_star_page:
		ld		l,a
		ld		a,(hl)
		ld		(star_fore_pgt+1),a		;13,17,1b

		; hscan番号セット
		ld		hl,#9300+8-2
		out		(c),l
		out		(c),h
		;HSYNC on
		ld		hl,#8012
		out		(c),l
		out		(c),h

		; 同期カウンタ更新
		xor		a
		ld		(0xcdd5),A

		jp		end_hkeyi
endp


;水平同期割り込み
on_hscan:
		;HSYNC off
		ld		hl,#8002
		out		(c),l
		out		(c),h

		; タイトル画面のときはこれで終了
		ld		a,(0xcde4)
		or		a
		jr		z, hscan_cycle_end

		; 色消す(CT:#12000)
		ld		hl,#8a04
		out		(c),l
		out		(c),h
		; 主処理
hscan_func_ptr:
		call	hscan_proc_mainscreen

		; 次段hscan取得
		ld		hl,hscan_adr
		ld		l,(hl)
		ld		a,(hl)
		or		a
		jr		z, hscan_cycle_end	; BGMを流して終了

		; hscanを次へ
		ld		l,hscan_adr
		inc		(hl)

		; hscan番号セット
		add		a,b
		out		(c),a
		ld		h,#93
		out		(c),h
		;HSYNC on
		ld		hl,#8012
		out		(c),l
		out		(c),h

		jp		end_hkeyi


; 全段hscan終了
hscan_cycle_end:
		; 割り込みラインインデックス先頭へ
		ld		a,hscan_adr+1
		ld		(hscan_adr),a

		; 次期ライン時処理切り替え
		ld		hl,hscan_proc_textscreen
		ld		(hscan_func_ptr+1),hl

		; BGM処理
sound_driver_func:
		call	#b2f7

end_hkeyi:
		in		a,(#99)	; ステータス読み捨て/tRの場合ret
		pop		af

		pop		ix
		pop		iy
		pop		af
		pop		bc
		pop		de
		pop		hl
		ex		af,af'
		exx
		pop		af
		pop		bc
		pop		de
		pop		hl
		ei
		ret


hscan_proc_textscreen:
		; sprite attriburte table
		ld		hl,fore_page
		ld		a,(hl)
		add		a,3
		ld		l,a
		ld		a,(hl)
		inc		a
		ld		b,#85

		ld		hl,#80+18 +((#80+23)<<8)
		ld		de,#820e	; pnt:0x3800
		; sprite attriburte table
		out		(c),a
		out		(c),b
		xor		a
		;scrollリセット
		out		(c),a
		out		(c),h
		;adjustリセット
		out		(c),a
		out		(c),l
		;ステータス表示のname tableへ
		out		(c),e
		out		(c),d

		; 文字用PGT(#0000)
		ld		hl,#8403
		; 色戻す(CT:#2000)
		ld		de,#8a00
		out		(c),l
		out		(c),h
		out		(c),e
		out		(c),d

		; 次段hscan処理切り替え
		ld		hl,hscan_proc_mainscreen
		ld		(hscan_func_ptr+1),hl

		; b:現在のスクロールy=0
		ld		b,a			; b:現在のスクロールy=0
		ret

hscan_proc_mainscreen:
		ld		hl,fore_page
		ld		l,(hl)

		ld		de,#9297
		;set adjust
		outi
		out		(c),d
		;set scroll
		ld		a,(hl)
		outi
		out		(c),e

		ld		de,#8285
		; PNT
		outi
		out		(c),d
		; SAT
		outi
		out		(c),e

		; スプライト表示再開
		ld		hl,#8808
		out		(c),l
		out		(c),h

		; b:現在のスクロールy
		ld		b,a

		; ゲームPGT(#8000/#a000/#c000,13/17/1b)
		ld		h,#84
star_fore_pgt:
		ld		a,0
		; 色戻す(CT:#e000)
		ld		de,#8a03
		out		(c),a
		out		(c),h
		out		(c),e
		out		(c),d

		; 次段hscan処理切り替え
		ld		hl,hscan_proc_textscreen
		ld		(hscan_func_ptr+1),hl

		ret


;===============================================================
; サウンドドライバ切り替え
;===============================================================
switch_sound_driver:
proc
		ld		hl,_call_default_driver;#b2f7
		ld		a,(cfg_sound_driver)
		or		a
		jr		z,_set
		ld		hl,_call_adxp_scan
	_set:
		ld		a,(sound_driver_func+1)
		cp		l
		ret		z
		ld		(sound_driver_func+1),hl
		ld		hl,#ce88
		res		7,(hl)
		inc		l
		res		7,(hl)
		ld		l,#95
		res		7,(hl)
		ret
	_call_default_driver:
		ld		a,(0xce82)
		or		a
		ret		nz
		ld		ix,#b2f7
		ld		iyl,3
		jp		call_bank_A000
	_call_adxp_scan:
		nop
		ld		a,#c9
		ld		(_call_adxp_scan),a
		ld		ix,ADXIF_scan
		ld		iyl,bank_adxif
		call	call_bank_4000
		xor		a
		ld		(_call_adxp_scan),a
		ret
endp
stop_sound_driver:
		xor		a
		ld		(#ce95),a
		halt
		xor		a
		ld		(#ce82),a
		ld		a,7
		ld		e,#b8
		call	#0093
		halt
		call	switch_sound_driver
		halt
		ret



my_hkey_end:
org		my_hkey_src + my_hkey_end-my_hkey_org
