;===============================================================
;  MSX STAR SOLDIER
;
;	基本PCG書き込み
;
;===============================================================

;===============================================================
;	基本PCG書き込み
;===============================================================
setup_pcg:
proc
		ld		hl,pcgcol_lzsa
		call	DecompressLZSA_to_d600
		call	setup_pcg_msg

		ld		hl,#d600	; PGT用ソース
		push	hl
		ld		d,l			; 書き込み先:0000
		ld		e,l
		ld		b,#03		; PGT3面、CT3面
		call	_wrt

		ld		hl,pcgcol_lzsa
		call	DecompressLZSA_to_d600
		call	setup_pcg_star

		pop		hl			; ソース=PGT
		ld		d,#80		; 書き込み先
		ld		b,#0c		; PGT12面、CT4面
	_wrt:
		call	_lp_wrt
		ld		h,#de		; CT用ソース
		ld		b,4
		cp		#18
		jr		nz,_lp_wrt
		dec		b
		ld		d,#20
	_lp_wrt:
		push	hl
		push	bc
		ld		b,#8
		call	blt_to_vram
		ld		a,d
		add		a,8
		ld		d,a
		pop		bc
		pop		hl
		djnz	_lp_wrt
		ret
endp


;===============================================================
;	PCGの準備
;		特定のメッセージ用に4ビットシフトしたものを作る
;===============================================================
setup_pcg_msg:
proc
		ld		hl,#20*8+8 + #d600
		exx
		ld		hl,#20*8 + #d600
		ld		de,_src
		ld		b,_end_src-_src
	_lp:
		ld		a,(de)
		exx
		or		a
		ld		d,#02 + #d6
		jr		nz,_nz
		ld		d,#d6
	_nz:
		ld		e,a
		ld		b,8
	_lp_merge:
		ld		a,(de)
		rld
		inc		hl
		exx
		rrca
		rrca
		rrca
		rrca
		rld
		inc		hl
		exx
		inc		de
		djnz	_lp_merge

		exx
		inc		de
		djnz	_lp

		ld		hl,#20*8 + #d600+#800
		ld		de,#20*8 + #d600+#800 +1
		ld		bc,8*(_end_src-_src+1)
		ld		(hl),#f0
		ldir
		ret

	_src:
		db		0,"B"*8,"R"*8,"A"*8,"I"*8,"N"*8,0
		db		0,"S"*8,"T"*8,"A"*8,"G"*8,"E"*8,0
	_end_src:
endp





;===============================================================
;	PCGの準備
;		文字の部分のPCGを引っ越して星用に空ける
;===============================================================
setup_pcg_star:
proc
		call	_mv_chr

	; #40-#5fまでを消す
		ld		hl,#d600+#40*8
		ld		(hl),0
		call	_fil
		ld		hl,#d600+#40*8 + #800
		ld		(hl),#70
	_fil:
		push	hl
		pop		de
		inc		de
		ld		bc,#ff
		ldir
		ret

	; _src_datを#30〜へ引っ越し
	_mv_chr:
		ld		h,+(#d600+#40*8)>>8
		ld		de,#d600+#30*8
		call	_mv
		ld		h,+(#d600+#40*8 + #800)>>8
		ld		de,#d600+#30*8 + #800
	_mv:
		ld		bc,_src_dat
	_lp:
		ld		a,(bc)
		ld		l,a
		inc		c
		ld		a,(bc)
		or		a
		ret		z
		inc		c
		push	bc
		ld		b,0
		ld		c,a
		ldir
		pop		bc
		jr		_lp
	_src_dat:
		db		#00,8, #50,8, #88,8, #c8,8*7, 0,0
endp

val_40_in_rom_03cce	equ	#30
val_4a_in_rom_03e74	equ	#31
val_51_in_rom_03cd1	equ	#32
val_59_in_rom_03eaf	equ	#33
val_59_in_rom_03eb1	equ	#33
val_5a_in_rom_03e5c	equ	#34
val_5a_in_rom_03e5f	equ	#34
val_5b_in_rom_03cd4	equ	#35
val_5c_in_rom_03e6c	equ	#36
val_5d_in_rom_03e4c	equ	#37
val_5d_in_rom_03e4d	equ	#37
val_5d_in_rom_03e51	equ	#37
val_5d_in_rom_03e59	equ	#37
val_5d_in_rom_03e6d	equ	#37
val_5d_in_rom_03e75	equ	#37
val_5d_in_rom_03e79	equ	#37
val_5d_in_rom_03e7d	equ	#37
val_5e_in_rom_03e50	equ	#38
val_5e_in_rom_03e5e	equ	#38
val_5e_in_rom_03e61	equ	#38
val_5f_in_rom_03e54	equ	#39
val_5f_in_rom_03e65	equ	#39
val_5f_in_rom_03e66	equ	#39


;from array import array
;with open("StarSoldier.rom","rb") as f:
;  d=array("B",f.read()[0x3c96:0x3f0e])
;
;for i,s in enumerate([0x40,0x4a,0x51]+range(0x59,0x60)):
;  for j in ["val_%x_in_rom_0%x\tequ\t#%x"%(s,0x3c96+j,0x30+i) for j,v in enumerate(d) if s==v]:
;    print j
