;===============================================================
;  MSX STAR SOLDIER
;
;	星
;
;===============================================================
star_rnd_src		equ	#440a


bit_ptn_reversed:
	db		128,64,32,16,8,4,2,1

star_yvec_tbl:
	db		0,0,0,1,1,2
star_yvec_at_start:
	db		3
star_yvec_at_nextstage:
	db		6,12,24
star_yvec_at_escape:
	db		-5,-10,-15


;===============================================================
;	星を配置
;===============================================================
star_put_1line:
proc
		ld		hl,star_rnd_src
		ld		b,#10
	_lp:
	    ld		a,(hl)
		inc		l
		add		a,c
		and		#0f
		add		a,#40	; 星のpcgの番号先頭一列目用
		ld		(de),a
		inc		de
		add		a,#10	; 星のpcgの番号先頭二列目用
		ld		(de),a
		inc		de
		djnz	_lp
		ret
endp

star_build_bg:
proc
		ld		de,#c300
		ld		c,0
	_lp:
		call	star_put_1line
		inc		c
		ld		a,c
		cp		#20
		jr		nz,_lp
		ret
endp

star_put_boss_1line:
proc
	; 1プレーン分書く
		ld		de,#c300
		ld		hl,star_last_src_y
		ld		a,(hl)
        dec		(hl)
		ld		c,a

		call	star_put_1line

	; 残り15プレーン分コピー
		ld		hl,#c300
		ld		bc,32*15
		ldir
		ret
endp



;===============================================================
;	星を更新
;===============================================================
star_update:
proc
	; 縦移動
		ld		hl,star_yvec_tbl
	; y vec
		ld		a,(#c1e1)
		or		a
		jr		z,_normal
		jp		m,_normal
		cp		7
		jr		nc,_at_start
		ld		a,(#cf1a)
		or		a
		jr		z,_at_nextstage
	;_at_escape:
		ld		l,star_yvec_at_escape
		jr		_mv_y
	_at_nextstage:
		ld		l,star_yvec_at_nextstage
		jr		_mv_y
	_at_start:
		ld		l,star_yvec_at_start
		jr		_mv_y
	_normal:
		ld		a,(#cf19)
		and		3
		add		a,l
		ld		l,a
	_mv_y:
		ld		de,star_y_tbl
		ld		b,3
	_lp_mv_y:
		ld		a,(de)
		add		a,(hl)
		ld		(de),a
		inc		e
		inc		hl
		djnz	_lp_mv_y
endp
proc
	; 描画パラメータ決定
	; y scr ofs
		ld		hl,back_page
		ld		l,(hl)
		inc		l
		ld		a,(hl)		; back_pageの y scr ofs
		ld		iyh,a				;

	; 左右位置
		ld		a,(#cddd)
		or		a
		jp		nz,_mormal_x
	_boss_x:
		ld		a,(#cf17)
		ld		ixh,a		; 左右位置
		ld		a,(star_boss_shift_x)
		ld		ixl,a
		jp		_end_x
	_mormal_x:
		ld		a,(#cde9)	; mx
		rrca
		rrca
		and		#3f
		ld		ixh,a		; 左右位置
		rrca
		rrca
		rrca
		and		#07
		ld		(star_boss_shift_x),a
		ld		ixl,a		; 左右振れ幅
	_end_x:


		ld		de,star_y_tbl+star_cnt-1
		ld		iyl,star_cnt
	_lp_mkparam:
		; 縦位置決定
		ld		a,(de)
		dec		e
		rrca
		add		a,iyh				; y scr ofs
		and		#7f
		ld		c,a					; pcg adr low

		; 横関係
		ld		a,ixh
		sub		ixl
		and		#7
		ld		b,a

		add		a,ixl
		sub		8
		jr		nc,_end_shift
		set		7,c					; pcg adr low
	_end_shift:
		; 左右振れ幅減らしてく
		ld		a,ixl
		srl		a
		ld		ixl,a

		; ビットパターン取得
		ld		a,b
		ld		h,bit_ptn_reversed>>8
		add		a,bit_ptn_reversed
		ld		l,a
	if	0xf8 < (bit_ptn_reversed & 0x0ff)
		jr		nc,_nc_bit_ptn
		inc		h
	_nc_bit_ptn:
	endif
		ld		b,(hl)				; ビットパターン

		; pcgアドレス、ビットパターンをスタックに
		push	bc

		dec		iyl
		jp		nz,_lp_mkparam
endp
proc
	; PCG書き込み
		ld		hl,star_back_page
		ld		l,(hl)
		inc		l
		ld		d,(hl)				; pcg high adr
		inc		l
		call	set_vram_adr_de

		ld		ixl,star_cnt
	_lp_write_star:
		ld		e,(hl)
		ld		d,0
		ld		b,4
	_lp_erase:
		inc		c
		di
		out		(c),e
		out		(c),a
		ei
		dec		c
		out		(c),d
		add		a,8
		djnz	_lp_erase

		pop		de
		ld		(hl),e
		inc		l
		ld		b,4
	_lp_write:
		sub		8
		inc		c
		di
		out		(c),e
		out		(c),a
		ei
		dec		c
		out		(c),d
		djnz	_lp_write

		dec		ixl
		jp		nz,_lp_write_star
		ret
endp




;===============================================================
;	星の初期化
;===============================================================
star_setup:
proc
		ld		hl,star_page_tbl
		ld		(hl),#13
		inc		l
		ld		(hl),#82
		inc		l
		ld		(hl),0
		ld		de,star_page_tbl+3
		ld		bc,star_page_cnt*star_page_size-3
		ldir
		inc		l
		ld		(hl),star_page_tbl
		ld		l,star_page_tbl+star_page_size*1
		ld		(hl),#17
		inc		l
		ld		(hl),#a2
		ld		l,star_page_tbl+star_page_size*2
		ld		(hl),#1b
		inc		l
		ld		(hl),#c2

		;ld		hl,star_y_tbl
		ld		l,star_y_tbl
	    ld		b,star_cnt
	_lp_init_y_tbl:
		ld		c,a
    	ld		a,r
    	add		a,c
    	add		a,b
    	ld		(hl),a
    	inc		l
		djnz	_lp_init_y_tbl
		ld		(hl),0

		jp		star_build_bg
endp
